package com.dsic.gj_erp.controller.jhgk;


import com.alibaba.fastjson.JSONObject;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.DmZrcjh;
import com.dsic.gj_erp.service.jhgk.DmZrcjhService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@RestController
@RequestMapping("/dmZrcjh")
@Api(tags = "中日程计划")
public class DmZrcjhController {
    @Autowired
    DmZrcjhService dmZrcjhService;

    @ApiOperation(value = "查询")
    @PostMapping(value = "/getList")
    public ResultBean getList(@RequestBody JSONObject json) {
        List<DmZrcjh> dmZrcjhs= dmZrcjhService.getList(json);
        return new ResultBean(dmZrcjhs);
    }

    @ApiOperation(value = "导入excel")
    @PostMapping(value = "/upload")
    @AuthFunction
    @ResponseBody
    public ResultBean upload(@RequestParam("file") MultipartFile file, HttpServletRequest req) throws IOException {
        List<DmZrcjh> dmZrcjhs= dmZrcjhService.upload(file,req);
        return new ResultBean(dmZrcjhs);
    }

    @ApiOperation(value = "批量保存")
    @PostMapping(value = "/save")
    @AuthFunction()
    public ResultBean save(@RequestBody List<DmZrcjh> dmZrcjhs, HttpServletRequest req) {
        dmZrcjhService.save(req,dmZrcjhs);
        return new ResultBean();
    }

    @ApiOperation(value = "批量提交")
    @PostMapping(value = "/tj")
    public ResultBean tjOrTh(@RequestBody List<DmZrcjh> dmZrcjhs) {
        dmZrcjhService.tj(dmZrcjhs);
        return new ResultBean();
    }

    @ApiOperation(value = "批量审核")
    @PostMapping(value = "/sh")
    public ResultBean sh(@RequestBody List<DmZrcjh> dmZrcjhs) {
        dmZrcjhService.sh(dmZrcjhs);
        return new ResultBean();
    }
}

