package com.dsic.gj_erp.controller.pgd;


import cn.hutool.core.date.DateUtil;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.DmYdjhLj;
import com.dsic.gj_erp.mapper.pgd.PgdQmjhMapper;
import com.dsic.gj_erp.service.jhgk.DmQfxqService;
import com.dsic.gj_erp.service.jhgk.DmYdjhLjService;
import com.dsic.gj_erp.service.pgd.DmPpxxbService;
import lombok.AllArgsConstructor;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-12-14
 */
@RestController
@RequestMapping("/dmPpxxb")
@AllArgsConstructor
public class DmPpxxbController {

    private final DmQfxqService qfxqService;
    private final DmPpxxbService ppxxbService;
    private final PgdQmjhMapper pgdQmjhMapper;
    private final DmYdjhLjService dmYdjhLjService;

//    @PostMapping("getDmppxxbList")
//    public ResultBean<?> getDmppxxbList(@RequestBody DmPpxxb dmPpxxb){
//        List<DmPpxxb> list = ppxxbService.list(Wrappers.<DmPpxxb>lambdaQuery()
//                .eq(DmPpxxb::getDcCh, dmPpxxb.getDcCh())
//                .eq(StrUtil.isNotEmpty(dmPpxxb.getDwh()),DmPpxxb::getDwh, dmPpxxb.getDwh())
//                .eq(StrUtil.isNotEmpty(dmPpxxb.getQy()),DmPpxxb::getQy, dmPpxxb.getQy())
//        );
//        return new ResultBean<>(list);
//    }

    @PostMapping("getDmppxxbList")
    public ResultBean<?> getDmppxxbList(@RequestBody Map map){
        List<DmYdjhLj> dmYdjhLjs = pgdQmjhMapper.selectQmByQgAndJh1(map);
        return new ResultBean<>(dmYdjhLjs);
    }

    @PostMapping("saveDmppxxb")
    @Transactional(rollbackFor = Exception.class)
    public ResultBean<?> save(@RequestBody List<DmYdjhLj> list){
        List<DmYdjhLj>adds =new ArrayList<>();
        list.forEach(e->{
            DmYdjhLj dmYdjhLj= new DmYdjhLj();
                dmYdjhLj.setId(e.getId());
                dmYdjhLj.setQq(e.getQq());
                dmYdjhLj.setDw(e.getDw());
                dmYdjhLj.setPpzt("02");
            adds.add(dmYdjhLj);
        });
        dmYdjhLjService.updateBatchById(adds);

//        list.forEach(item-> item.setZt("00"));
//        ppxxbService.saveOrUpdateBatchByMultiId(list);
        return new ResultBean<>();
    }


    @PostMapping("saveDmppxxbpg")
    @Transactional(rollbackFor = Exception.class)
    @AuthFunction
    public ResultBean<?> saveDmppxxbpg(@RequestBody List<DmYdjhLj> list, HttpServletRequest request){
        String bzry= (String) request.getAttribute("yhms");
        String bzrq= DateUtil.format(DateUtil.date(), "yyyy/MM/dd");
        List<DmYdjhLj>adds =new ArrayList<>();
        list.forEach(e->{
            DmYdjhLj dmYdjhLj= new DmYdjhLj();
            dmYdjhLj.setId(e.getId());
            dmYdjhLj.setPpzt("03");
            dmYdjhLj.setRkry(bzry);
            dmYdjhLj.setRkrq(bzrq);
            adds.add(dmYdjhLj);
        });
        dmYdjhLjService.updateBatchById(adds);

//        list.forEach(item-> item.setZt("00"));
//        ppxxbService.saveOrUpdateBatchByMultiId(list);
        return new ResultBean<>();
    }

    @PostMapping("saveDmppxxbqr")
    @Transactional(rollbackFor = Exception.class)
    @AuthFunction
    public ResultBean<?> saveDmppxxbqr(@RequestBody List<DmYdjhLj> list, HttpServletRequest request){
        String bzry= (String) request.getAttribute("yhms");
        String bzrq= DateUtil.format(DateUtil.date(), "yyyy/MM/dd");
        List<DmYdjhLj>adds =new ArrayList<>();
        list.forEach(e->{
            DmYdjhLj dmYdjhLj= new DmYdjhLj();
            dmYdjhLj.setId(e.getId());
            dmYdjhLj.setPpzt("04");
            dmYdjhLj.setQrry(bzry);
            dmYdjhLj.setQrrq(bzrq);
            adds.add(dmYdjhLj);
        });
        dmYdjhLjService.updateBatchById(adds);

//        list.forEach(item-> item.setZt("00"));
//        ppxxbService.saveOrUpdateBatchByMultiId(list);
        return new ResultBean<>();
    }

}

