package com.dsic.gj_erp.service.jhgk.impl;


import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jhgk.DmQfxq;
import com.dsic.gj_erp.bean.jhgk.DmSygdMx;
import com.dsic.gj_erp.bean.jhgk.DmYdjh;
import com.dsic.gj_erp.bean.pgd.*;
import com.dsic.gj_erp.mapper.jhgk.DmYdjhMapper;
import com.dsic.gj_erp.service.jhgk.DmQfxqService;
import com.dsic.gj_erp.service.jhgk.DmYdjhService;
import com.dsic.gj_erp.service.jiuzhou.SljhService;
import com.dsic.gj_erp.service.pgd.*;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.stream.Collectors;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-11-09
 */
@SuppressWarnings("ALL")
@Service
public class DmYdjhServiceImpl extends ServiceImpl<DmYdjhMapper, DmYdjh> implements DmYdjhService {

    @Autowired
    private DmQfxqService qfxqService;
    @Autowired
    private PgdTzjhService tzjhService;
    @Autowired
    private PgdDhService dhService;
    @Autowired
    private PgdSljhService slService;
    @Autowired
    private PgdPwjhService pwService;
    @Autowired
    private PgdQgjhService qgService;
    @Autowired
    private SljhService sljhService;

    @Override
    public List<DmSygdMx> tjydjh() {
        //根据 前方需求 三月滚动 排产
        //1.查看下月的前方需求是否已导入
        //2.根据前方需求的 船号、批量，查找三月滚动明细（板）
        //3.根据前方需求期，重新为三月滚动明细排产（板），排产后的数据添加到月度计划，并且反写数据到三月滚动明细
//      List<DmQfxq> qfxqList= qfxqService.list(new QueryWrapper<DmQfxq>().eq("substring(db,0,8) ", DateUtil.format(DateUtil.nextMonth(),"yyyy/MM")));
        int i = qfxqService.count(new QueryWrapper<DmQfxq>()
                .eq("substring(xzglxq,0,8) ", DateUtil.format(DateUtil.nextMonth(), "yyyy/MM")));
        if (i < 1) {
            System.out.println("下月的前方需求信息未导入！");
            return null;
        }
        List<DmSygdMx> sygdmx = baseMapper.getSygdmx(DateUtil.format(DateUtil.nextMonth(),"yyyy/MM"));
        if (sygdmx.size() < 1) {
            System.out.println("请导入零件配套表信息！");
        }
        // 判断要是不满足条件不可以提交
        //TODO 重新排产
//        pc(sygdMxList);

        return sygdmx;

    }

    @Override
    @Transactional
    public Map<String,Object> hz2(String from, String to){
        Map<String,Object> map=new HashMap<>();
        //月度计划汇总
        //汇总时生成切割之前的派工单 状态为空
        String begin=from;
        String end=to;
//        String begin= DateUtil.format(from,"yyyy/MM/01");
//        String end =DateUtil.format(DateUtil.endOfMonth(DateUtil.offsetMonth(DateUtil.date(),1)),"yyyy/MM/dd");
        //图纸计划

        List<PgdTzjh> tzjhList=   baseMapper.getTzjh1(begin,end);

        //订货清单
        List<PgdDh> dhList=baseMapper.getDhjh(begin,end);

        //上料计划
        List<PgdSljh> slList= baseMapper.getSljh1(begin,end);

        //抛丸计划

        List<PgdPwjh> pwList= baseMapper.getPwjh1(begin,end);

        //切割计划
        List<PgdQgjh> qgList= baseMapper.getQgjh1(begin,end);
        List<DmYdjh> list= this.list(new QueryWrapper<DmYdjh>()

            .eq("zt","0")
            .ge( "jssj", DateUtil.beginOfMonth(DateUtil.parseDate(from)).toString("yyyy/MM/dd"))
            .le( "jssj", DateUtil.endOfMonth(DateUtil.parseDate(to)).toString("yyyy/MM/dd"))
            .orderByAsc("jssj,dc_ch,dc_pl,zl,lqlb")
        );
        for(DmYdjh dmYdjh :list){
            PgdTzjh pgdTzjh = tzjhList.stream().filter(fst -> fst.getCzbh().equals(dmYdjh.getDcCh()) && fst.getPl().equals(dmYdjh.getDcPl())
            ).findFirst().orElse(null);
            if(null!=pgdTzjh){
                dmYdjh.setPgdTzjh(pgdTzjh);
                //领取表 早于上料日期
                //  套料图早于划线日期
                if(StringUtils.isBlank(pgdTzjh.getLqbxfrq())||StringUtils.isBlank(dmYdjh.getSljhrq()) ){
                    // corlor  red
                    dmYdjh.setColor("red");
                }else{

                    DateTime dateStr1 = DateUtil.parse(pgdTzjh.getLqbxfrq(), "yyyy/MM/dd");
                    DateTime dateStr2 = DateUtil.parse(dmYdjh.getSljhrq(), "yyyy/MM/dd");
                    int result = DateUtil.compare(dateStr1, dateStr2);
                    if (result > 0) {
                        System.out.println(dateStr1 + " is after " + dateStr2);
                        dmYdjh.setColor("red");
                    } else if (result < 0) {
                        System.out.println(dateStr1 + " is before " + dateStr2);

                    } else {
                        System.out.println(dateStr1 + " is equal to " + dateStr2);
                        dmYdjh.setColor("yellow");
                    }
                }
                if(StringUtils.isBlank(pgdTzjh.getTltxfrq())||StringUtils.isBlank(dmYdjh.getHxjhrq()) ){
                    // corlor  yellow
                    dmYdjh.setColor("red");
                }else{


                    DateTime dateStr1 = DateUtil.parse(pgdTzjh.getTltxfrq(), "yyyy/MM/dd");
                    DateTime dateStr2 = DateUtil.parse(dmYdjh.getHxjhrq(), "yyyy/MM/dd");
                    int result = DateUtil.compare(dateStr1, dateStr2);
                    if (result > 0) {
                        System.out.println(dateStr1 + " is after " + dateStr2);
                        dmYdjh.setColor("red");
                    } else if (result < 0) {
                        System.out.println(dateStr1 + " is before " + dateStr2);

                    } else {
                        System.out.println(dateStr1 + " is equal to " + dateStr2);
                        dmYdjh.setColor("yellow");
                    }
                }
            }else {
                dmYdjh.setColor("red");
            }


        }
        map.put("tzjhList",tzjhList);
        map.put("dhList",dhList);
        map.put("slList",slList);
        map.put("pwList",pwList);
        map.put("qgList",qgList);
        map.put("list",list);
        return map;
    }

//    @Override
//    @Transactional
//    public Map<String,Object> hz(List<DmYdjh> ydjhList){
//        Map<String,Object> map=new HashMap<>();
//        //月度计划汇总
//        //汇总时生成切割之前的派工单 状态为空
//        String begin= DateUtil.format(DateUtil.nextMonth(),"yyyy/MM/01");
//        String end =DateUtil.format(DateUtil.endOfMonth(DateUtil.offsetMonth(DateUtil.date(),1)),"yyyy/MM/dd");
//        //图纸计划
//
//        List<PgdTzjh> tzjhList=tzjhService.list(new QueryWrapper<PgdTzjh>().between("qgxqrq",begin,end).orderByAsc("czbh,pl,qgxqrq"));
//        if (tzjhList.size()<1){
//            baseMapper.getTzjh(begin,end);
//            tzjhList=tzjhService.list(new QueryWrapper<PgdTzjh>().between("qgxqrq",begin,end)
//                    .orderByAsc("czbh,pl,qgxqrq")
//            );
//        }
//        //订货清单
//        List<PgdDh> dhList=dhService.list(new QueryWrapper<PgdDh>().between("slxqrq",begin,end).orderByAsc("czbh,slxqrq"));
//        if (dhList.size()<1){
//            List<PgdDh> dh= baseMapper.getDhjh(begin,end);
//            if (dh.size()>0){
//
//                dhService.saveBatch(dh);
//                dhList=dhService.list(new QueryWrapper<PgdDh>().between("slxqrq",begin,end).orderByAsc("czbh,slxqrq"));
//            }
//        }
//        //上料计划
//        List<PgdSljh> slList=slService.list(new QueryWrapper<PgdSljh>().between("sljhrq",begin,end).orderByAsc("czbh,pl,sljhrq"));
//        if (slList.size()<1){
//            baseMapper.getSljh(begin,end);
//            slList=slService.list(new QueryWrapper<PgdSljh>().between("sljhrq",begin,end).orderByAsc("czbh,pl,sljhrq"));
//        }
//        //抛丸计划
//
//        List<PgdPwjh> pwList=pwService.list(new QueryWrapper<PgdPwjh>().between("pwjhrq",begin,end).orderByAsc("czbh,pl,pwjhrq"));
//        if (pwList.size()<1){
//            baseMapper.getPwjh(begin,end);
//            pwList=pwService.list(new QueryWrapper<PgdPwjh>().between("pwjhrq",begin,end).orderByAsc("czbh,pl,pwjhrq"));
//        }
//        //切割计划
//        List<PgdQgjh> qgList=qgService.list(new QueryWrapper<PgdQgjh>().between("qgjhrq",begin,end).orderByAsc("czbh,pl,qgjhrq"));
//        if (qgList.size()<1){
//            baseMapper.getQgjh(begin,end);
//            qgList=qgService.list(new QueryWrapper<PgdQgjh>().between("qgjhrq",begin,end).orderByAsc("czbh,pl,qgjhrq"));
//        }
//        map.put("tzjhList",tzjhList);
//        map.put("dhList",dhList);
//        map.put("slList",slList);
//        map.put("pwList",pwList);
//        map.put("qgList",qgList);
//        return map;
//    }

    @Resource
    private ApplicationEventPublisher publisher;

    @Autowired
    private RedisTemplate<String,Object> redisTemplate;

    //下发 派工单状态改为编制 生成零件信息
    @Override
    @Transactional(rollbackFor = Exception.class)
    public void xf(List<DmYdjh> ydjhList, HttpServletRequest request) {
        String bzry= (String) request.getAttribute("yhms");
        String bzrq= DateUtil.format(DateUtil.date(), "yyyy/MM/dd");

        String gxsj=DateUtil.date().toString("yyyy/MM/dd HH:mm:ss");
        //工单号
        List<DmYdjh> updateList = ydjhList.stream()
                .filter(item->StrUtil.isNotEmpty(item.getSljhrq()))
                .map(item->ofXf(item,gxsj)).collect(Collectors.toList());

        this.updateBatchById(updateList);

        List<String> idList = ydjhList.stream().map(DmYdjh::getId).collect(Collectors.toList());

        idList.forEach(item->{
            List<PgdDh> dh= baseMapper.getDhjh1(item);
            if (dh.size()>0){
                dhService.saveBatch(dh);
            }
        });

        if (idList.size() > 100) {
            List<String> list = idList.subList(idList.size() / 100 * 100, idList.size());
            AtomicInteger index = new AtomicInteger(idList.size() / 100 + 1);

//            this.update(new UpdateWrapper<DmYdjh>().set("zt", "2")
//                    .in("id", list)
//            );

            // 生成 数据
            baseMapper.getTzjh(list,bzry,bzrq);

            //作业计划零件数据
            baseMapper.tqlj(list);
            do {
                int i = index.decrementAndGet();
                List<String> list1 = idList.subList((index.get() - 1) * 100, i * 100);
                this.update(new UpdateWrapper<DmYdjh>().set("zt", "2")
                        .in("id", list1)
                );
                baseMapper.getTzjh(list1,bzry,bzrq);

                //作业计划零件数据
                baseMapper.tqlj(list1);
            }while (index.get()>1);

        }else {
//            this.update(new UpdateWrapper<DmYdjh>().set("zt", "2")
//                    .in("id", idList)
//            );
//            //修改汇总状态 改为 编制
//            baseMapper.xfbc(idList);
//            //生成对应零件信息 bom->tzjhLj
//            baseMapper.tqlj(idList);
//            baseMapper.xfbc(idList);
            baseMapper.getTzjh(idList,bzry,bzrq);

            //作业计划零件数据
            baseMapper.tqlj(idList);
        }

        publisher.publishEvent(ydjhList);
    }

    private DmYdjh ofXf(DmYdjh item,String gxsj){
        Long djh=this.handlerDjh(item);
        DmYdjh dmYdjh = new DmYdjh();
        dmYdjh.setId(item.getId());
        dmYdjh.setZt("2");
        String perfix=item.getSljhrq().replace("/","");
        perfix=perfix.substring(2);
        dmYdjh.setDjh(StrUtil.format("{}{}",perfix, String.format("%03d",djh)));
        dmYdjh.setGxsj(gxsj);
        return dmYdjh;
    }

    private Long handlerDjh(DmYdjh item){
        String key="ZYJH_GDH::";
        //从101开始生成工单号,方便工人念出
        if (ObjUtil.isEmpty(redisTemplate.opsForHash().get(key, item.getSljhrq()))) {
            redisTemplate.opsForHash().put(key, item.getSljhrq(),100);
        }
        return redisTemplate.opsForHash().increment(key, item.getSljhrq(), 1);
    }

}
